package Controladores.Factorias;

import java.util.Scanner;
import Model.Enumerate.Ficha;
import Model.Jugadores.Jugador;
import Model.Jugadores.JugadorAleatorioGravity;
import Model.Jugadores.JugadorHumanoGravity;
import Model.Movimientos.Movimiento;
import Model.Movimientos.MovimientoGravity;
import Model.Reglas.ReglasJuego;
import Model.Reglas.ReglasGravity;

public class FactoriaJuegoGravity implements FactoriaJuegos {
	
	//Atributos
	private int filas;
	private int columnas;
	
	//Constructores
	public FactoriaJuegoGravity(){
		super();
		
	}
	
	public FactoriaJuegoGravity(int filas, int columnas){
		this.filas = filas;
		this.columnas = columnas;
		
	}
	
	//Accedentes y mutadores
	public int getFilas(){
		return this.filas;
		
	}
	
	public int getColumnas(){
		return this.columnas;
		
	}
	
	public void setFilas(int filas){
		this.filas = filas;
		
	}
	
	public void setColumnas(int columnas){
		this.columnas = columnas;
		
	}
	
	@Override
	public ReglasJuego creaReglas() {
		// TODO Auto-generated method stub
		return new ReglasGravity();
	}

	@Override
	public Movimiento creaMovimiento(int fila, int columna, Ficha color) {
		// TODO Auto-generated method stub
		return new MovimientoGravity(fila, columna, color);
	}

	@Override
	public Jugador creaJugadorAleatorio() {
		// TODO Auto-generated method stub
		return new JugadorAleatorioGravity();
	}

	@Override
	public Jugador creaJugadorHumano(Scanner sc) {
		// TODO Auto-generated method stub
		return new JugadorHumanoGravity(sc);
	}

}
