package Controladores;

import Model.Enumerate.Ficha;
import Model.Exceptions.ErrorDeEjecucion;

public class PonerJugador implements Comandos {
	
	//Atributos
	private Ficha color;
	private String tipoJugador;
	
	//Constructores
	public PonerJugador(){
		
	}
	
	public PonerJugador(String tipoJugador, Ficha color){
		
		this.tipoJugador = tipoJugador;
		this.color = color;
		
	}
	
	//Accedentes y mutadores
	public Ficha getColor(){
		
		return this.color;
		
	}
	
	public String getTipoJugador(){
		
		return this.tipoJugador;
		
	}
	
	public void setColor(Ficha color){
		
		this.color = color;
		
	}
	
	public void setTipoJugador(String tipoJugador){
		
		this.tipoJugador = tipoJugador;
		
	}
	
	@Override
	public void execute(Controlador control) throws ErrorDeEjecucion {
		// TODO Auto-generated method stub
		try{
			System.out.println("Ha elegido cambiar el tipo del jugador.");
			control.ponerJugador(this.color, this.tipoJugador);
			System.out.println("Se ha cambiado correctamente el tipo de jugador.");
			System.out.print(System.getProperty("line.separator"));
		}
		catch(ErrorDeEjecucion e){
			System.out.println(e.getMessage());
		}
		
	}

	@Override
	public Comandos parsea(String[] cadena) {
		// TODO Auto-generated method stub
		Comandos ponerJugador = null;
		if((cadena.length == 3) && (cadena[0].equalsIgnoreCase("jugador"))){
			if((cadena[1].equalsIgnoreCase("blancas") && (cadena[2].equalsIgnoreCase("humano")))){
				this.tipoJugador = "humano";
				this.color = Ficha.BLANCA;
				ponerJugador = new PonerJugador(this.getTipoJugador(), this.getColor());
			}
			else if((cadena[1].equalsIgnoreCase("negras")) && (cadena[2].equalsIgnoreCase("humano"))){
				this.tipoJugador = "humano";
				this.color = Ficha.NEGRA;
				ponerJugador = new PonerJugador(this.getTipoJugador(), this.getColor());
			}
			else if((cadena[1].equalsIgnoreCase("blancas")) && (cadena[2].equalsIgnoreCase("aleatorio"))){
				this.tipoJugador = "aleatorio";
				this.color = Ficha.BLANCA;
				ponerJugador = new PonerJugador(this.getTipoJugador(), this.getColor());
			}
			else if((cadena[1].equalsIgnoreCase("negras")) && (cadena[2].equalsIgnoreCase("aleatorio"))){
				this.tipoJugador ="aleatorio";
				this.color = Ficha.NEGRA;
				ponerJugador = new PonerJugador(this.getTipoJugador(), this.getColor());
			}
		}
		return ponerJugador;
	}

	@Override
	public String textoAyuda() {
		// TODO Auto-generated method stub
		String ayuda = "";
		ayuda = ayuda + (System.getProperty("line.separator"));
		ayuda = ayuda + (".-Si desea cambiar el tipo de jugador escriba una de las siguientes opciones:");
		ayuda = ayuda + (System.getProperty("line.separator"));
		ayuda = ayuda + ("   -1 opcion, escriba \"Jugador blancas humano\".");
		ayuda = ayuda + (System.getProperty("line.separator"));
		ayuda = ayuda + ("   -2 opcion, escriba \"Jugador blancas aleatorio\".");
		ayuda = ayuda + (System.getProperty("line.separator"));
		ayuda = ayuda + ("   -3 opcion, escriba \"Jugador negras humano\".");
		ayuda = ayuda + (System.getProperty("line.separator"));
		ayuda = ayuda + ("   -4 opcion, escriba \"Jugador negras aleatorio\".");
		ayuda = ayuda + (System.getProperty("line.separator"));
		return ayuda;
		
	}

}
