package Model.Jugadores;

import Model.Enumerate.*;
import Model.Exceptions.*;
import Model.Movimientos.*;
import Model.Tablero;
import Controladores.Factorias.*;
import java.util.InputMismatchException;

public abstract class Jugador {
	
	//Atributos
	protected int fila;
	protected int columna;
	
	//Accedentes
	public int getFila(){
		
		return this.fila;
		
	}
	
	public int getColumna(){
		
		return this.columna;
		
	}
	
	//Metodos abstractos
	public abstract void obtenFilaColumna(Tablero tablero, Ficha color);
	
	//Metodos
	public Movimiento getMovimiento(FactoriaJuegos factoria, Tablero tablero, Ficha color) throws DatosIncorrectos {
		
		try{
			this.obtenFilaColumna(tablero, color);
			Movimiento movimientoValido = factoria.creaMovimiento(this.getFila(), this.getColumna(), color);
			return movimientoValido;
		}
		catch(InputMismatchException e){
			throw new DatosIncorrectos("Los datos introducidos no son numericos.");
		}
		
	}

}
