package Model.Reglas;

import Model.Tablero;
import Model.Enumerate.Ficha;

public class ReglasComplica extends ReglasJuego {
	
	//Atributos
	public static final int FILAS = 7;
	public static final int COLUMNAS = 4;

	@Override
	public Tablero iniciaTablero() {
		// TODO Auto-generated method stub
		Tablero tablero = new Tablero(FILAS, COLUMNAS);
		return tablero;
	}
	
	private boolean hayCuatroEnLineaBlancas(Tablero tablero){
		
		boolean cuatroEnLineaBlancas = false;
		int filaBlancas = 0;
		while((filaBlancas < FILAS) && (!cuatroEnLineaBlancas)){
			int columnaBlancas = 0;
			while((columnaBlancas < COLUMNAS) && (!cuatroEnLineaBlancas)){
				if(ReglasJuegoCuatroEnLinea.cuatroEnLinea(tablero, Ficha.BLANCA, filaBlancas, columnaBlancas)){
					cuatroEnLineaBlancas = true;
				}
				else{
					columnaBlancas++;
				}
			}
			filaBlancas++;
		}
		return cuatroEnLineaBlancas;
		
	}
	
	private boolean hayCuatroEnLineaNegras(Tablero tablero){
		
		boolean cuatroEnLineaNegras = false;
		int filaNegras = 0;
		while((filaNegras < FILAS) && ((!cuatroEnLineaNegras))){
			int columnaNegras = 0;
			while((columnaNegras < COLUMNAS) && (!cuatroEnLineaNegras)){
				if(ReglasJuegoCuatroEnLinea.cuatroEnLinea(tablero, Ficha.NEGRA, filaNegras, columnaNegras)){
					cuatroEnLineaNegras = true;
				}
				else{
					columnaNegras++;
				}
			}
			filaNegras++;
		}
		return cuatroEnLineaNegras;
		
	}

	@Override
	public Ficha hayGanador(int fila, int columna, Ficha ultimo, Tablero tablero) {
		// TODO Auto-generated method stub
		Ficha ganadorPartida = Ficha.VACIA;
		//Comprobar si hay ganador, es decir que solo hay cuatro en linea de blancas o de negras
		if((this.hayCuatroEnLineaBlancas(tablero)) && (!this.hayCuatroEnLineaNegras(tablero))){
			ganadorPartida = Ficha.BLANCA;
		}
		else if((!this.hayCuatroEnLineaBlancas(tablero)) && (this.hayCuatroEnLineaNegras(tablero))){
			ganadorPartida = Ficha.NEGRA;
		}
		return ganadorPartida;
		
	}

	@Override
	public boolean tablas(Tablero tablero) {
		// TODO Auto-generated method stub
		return false;
	}

}
