package Model;

import Model.Enumerate.*;

public class Tablero {
	
	//Atributos
	private Ficha[][] tablero;
	private int ancho;
	private int alto;
	private int casillasOcupadas;
	
	//Constuctoras
	public Tablero(){
		
		this.ancho = 0;
		this.alto = 0;
		this.casillasOcupadas = 0;
		this.tablero = new Ficha[alto][ancho];
		this.reset();
		
	}
	
	public Tablero(int alto, int ancho){
		
		this.ancho = ancho;
		this.alto = alto;
		this.casillasOcupadas = 0;
		this.tablero = new Ficha[alto][ancho];
		this.reset();
		
	}
	
	//Accedentes y mutadores
	public int getAlto(){
		
		return this.alto;
		
	}
	
	public int getAncho(){
		
		return this.ancho;
		
	}
	
	public void setAlto(int alto){
		
		this.alto = alto;
		
	}
	
	public void setAncho(int ancho){
		
		this.ancho = ancho;
		
	}
	
	public int getCasillasOcupadas(){
		
		return this.casillasOcupadas;
		
	}
	
	public void setCasillasOcupadas(int casillasOcupadas){
		
		this.casillasOcupadas = casillasOcupadas;
		
	}
	
	//Metodos
	public Ficha getFicha(int fila, int columna){
		
		return tablero[fila][columna];
		
	}
	
	public void setFicha(int fila, int columna, Ficha ficha){
		
		this.tablero[fila][columna] = ficha;
		this.setCasillasOcupadas(this.getCasillasOcupadas()+1);
		
	}
	
	public void reset(){
		
		for(int fila = 0; fila < this.getAlto(); fila++){
			
			for(int columna = 0; columna < this.getAncho(); columna++){
				
				this.tablero[fila][columna] = Ficha.VACIA;
				
			}
			
		}
		this.setCasillasOcupadas(0);
		
	}
	
	public boolean columnaCorrecta(int columna){
		
		boolean esCorrecta = false;
		if((columna >= 0) && (columna < this.getAncho())){
			esCorrecta = true;
			
		}
		return esCorrecta;
	}
	
	public boolean filaCorrecta(int fila){
		
		boolean esCorrecta = false;
		if((fila >= 0) && (fila < this.getAlto())){
			esCorrecta = true;
			
		}
		return esCorrecta;
		
	}
	
	public boolean completo(){
		
		boolean tableroCompleto = false;
		int totalCasillas = this.getAlto() * this.getAncho();
		if(this.getCasillasOcupadas() == totalCasillas){
			tableroCompleto = true;
			
		}
		return tableroCompleto;
		
	}		
	
	public String toString(){
		
		String miString = "";
		for(int fila = this.getAlto()-1; fila >= 0; fila--){
			
			for(int columna = 0; columna < this.getAncho(); columna++){
				
				if(this.tablero[fila][columna] == Ficha.VACIA){
					miString = miString + "O ";
					
				}
				else if(this.tablero[fila][columna] == Ficha.BLANCA){
					miString = miString + "B ";
					
				}
				else if(this.tablero[fila][columna] == Ficha.NEGRA){
					miString = miString + "N ";
					
				}
				
			}
			miString = miString + System.getProperty("line.separator");
			
		}
		
		return miString;
		
	}
	
}
